/*
  File autogenerated by gengetopt version 2.12.1
  generated with the following command:
  gengetopt --input=xyzvol_cmp_cmd.ggo --file-name=xyzvol_cmp_cmd 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getopt.h"

#include "xyzvol_cmp_cmd.h"

static
void clear_given (struct gengetopt_args_info *args_info);
static
void clear_args (struct gengetopt_args_info *args_info);

static int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error);

static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct gengetopt_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->verbosity_given = 0 ;
  args_info->density_given = 0 ;
  args_info->inxyz_given = 0 ;
  args_info->xmin_given = 0 ;
  args_info->xmax_given = 0 ;
  args_info->ymin_given = 0 ;
  args_info->ymax_given = 0 ;
  args_info->zmin_given = 0 ;
  args_info->zmax_given = 0 ;
}

static
void clear_args (struct gengetopt_args_info *args_info)
{
  args_info->verbosity_arg = 0 ;
  args_info->density_arg = NULL;
  args_info->inxyz_arg = NULL;
  args_info->xmin_arg = -0.5 ;
  args_info->xmax_arg = 0.5 ;
  args_info->ymin_arg = -0.5 ;
  args_info->ymax_arg = 0.5 ;
  args_info->zmin_arg = -0.5 ;
  args_info->zmax_arg = 0.5 ;
}

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n", CMDLINE_PARSER_PACKAGE, CMDLINE_PARSER_VERSION);
}

void
cmdline_parser_print_help (void)
{
  cmdline_parser_print_version ();
  printf("\n"
  "Purpose:\n"
  "  Compare xyz values to a volume density... blobby volume density.\n  Only takes the first 3 values on each line and ignores the rest of the line.\n  Output is\n\n    x y z count %%_or_total_counts %%_cdf\n"
  "\n"
  "Usage: %s [OPTIONS]...\n", CMDLINE_PARSER_PACKAGE);
  printf("\n");
  printf("%s\n","  -h, --help              Print help and exit");
  printf("%s\n","  -V, --version           Print version and exit");
  printf("%s\n","  -v, --verbosity=INT     Set the verbosity level (0=quiet 10=verbose 20=\n                            bombastic)  (default=`0')");
  printf("%s\n","  -d, --density=filename  Density volume file.  .vol format");
  printf("%s\n","  -i, --inxyz=filename    Ascii x y z file.  One data item per line.  Space or \n                            tab delimited");
  printf("%s\n","  -x, --xmin=FLOAT        Minimum x coordinate\n                            If you specify and of [xyzXYZ], then the defaults \n                            kick in.\n                            Otherwise the value is determined by the density \n                            loader.  (default=`-0.5')");
  printf("%s\n","  -X, --xmax=FLOAT        Maximum X coordinate  (default=`0.5')");
  printf("%s\n","  -y, --ymin=FLOAT        Minimum y coordinate  (default=`-0.5')");
  printf("%s\n","  -Y, --ymax=FLOAT        Maximum Y coordinate  (default=`0.5')");
  printf("%s\n","  -z, --zmin=FLOAT        Minimum z coordinate  (default=`-0.5')");
  printf("%s\n","  -Z, --zmax=FLOAT        Maximum Z coordinate  (default=`0.5')");
}

void
cmdline_parser_init (struct gengetopt_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);
}

void
cmdline_parser_free (struct gengetopt_args_info *args_info)
{
  
  if (args_info->density_arg)
    {
      free (args_info->density_arg); /* free previous argument */
      args_info->density_arg = 0;
    }
  if (args_info->inxyz_arg)
    {
      free (args_info->inxyz_arg); /* free previous argument */
      args_info->inxyz_arg = 0;
    }
  
  clear_given (args_info);
}


/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = NULL;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  return cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
cmdline_parser2 (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required)
{
  int result;
  
  result = cmdline_parser_internal (argc, argv, args_info, override, initialize, check_required, NULL);
  
  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */
  int error = 0;
  struct gengetopt_args_info local_args_info;

  if (initialize)
    cmdline_parser_init (args_info);

  cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "verbosity",	1, NULL, 'v' },
        { "density",	1, NULL, 'd' },
        { "inxyz",	1, NULL, 'i' },
        { "xmin",	1, NULL, 'x' },
        { "xmax",	1, NULL, 'X' },
        { "ymin",	1, NULL, 'y' },
        { "ymax",	1, NULL, 'Y' },
        { "zmin",	1, NULL, 'z' },
        { "zmax",	1, NULL, 'Z' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVv:d:i:x:X:y:Y:z:Z:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          cmdline_parser_print_help ();
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          cmdline_parser_print_version ();
          exit (EXIT_SUCCESS);

        case 'v':	/* Set the verbosity level (0=quiet 10=verbose 20=bombastic).  */
          if (local_args_info.verbosity_given)
            {
              fprintf (stderr, "%s: `--verbosity' (`-v') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->verbosity_given && ! override)
            continue;
          local_args_info.verbosity_given = 1;
          args_info->verbosity_given = 1;
          args_info->verbosity_arg = strtol (optarg,&stop_char,0);
          break;

        case 'd':	/* Density volume file.  .vol format.  */
          if (local_args_info.density_given)
            {
              fprintf (stderr, "%s: `--density' (`-d') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->density_given && ! override)
            continue;
          local_args_info.density_given = 1;
          args_info->density_given = 1;
          if (args_info->density_arg)
            free (args_info->density_arg); /* free previous string */
          args_info->density_arg = gengetopt_strdup (optarg);
          break;

        case 'i':	/* Ascii x y z file.  One data item per line.  Space or tab delimited.  */
          if (local_args_info.inxyz_given)
            {
              fprintf (stderr, "%s: `--inxyz' (`-i') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->inxyz_given && ! override)
            continue;
          local_args_info.inxyz_given = 1;
          args_info->inxyz_given = 1;
          if (args_info->inxyz_arg)
            free (args_info->inxyz_arg); /* free previous string */
          args_info->inxyz_arg = gengetopt_strdup (optarg);
          break;

        case 'x':	/* Minimum x coordinate\nIf you specify and of [xyzXYZ], then the defaults kick in.\nOtherwise the value is determined by the density loader..  */
          if (local_args_info.xmin_given)
            {
              fprintf (stderr, "%s: `--xmin' (`-x') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->xmin_given && ! override)
            continue;
          local_args_info.xmin_given = 1;
          args_info->xmin_given = 1;
          args_info->xmin_arg = (float)strtod (optarg, NULL);
          break;

        case 'X':	/* Maximum X coordinate.  */
          if (local_args_info.xmax_given)
            {
              fprintf (stderr, "%s: `--xmax' (`-X') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->xmax_given && ! override)
            continue;
          local_args_info.xmax_given = 1;
          args_info->xmax_given = 1;
          args_info->xmax_arg = (float)strtod (optarg, NULL);
          break;

        case 'y':	/* Minimum y coordinate.  */
          if (local_args_info.ymin_given)
            {
              fprintf (stderr, "%s: `--ymin' (`-y') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->ymin_given && ! override)
            continue;
          local_args_info.ymin_given = 1;
          args_info->ymin_given = 1;
          args_info->ymin_arg = (float)strtod (optarg, NULL);
          break;

        case 'Y':	/* Maximum Y coordinate.  */
          if (local_args_info.ymax_given)
            {
              fprintf (stderr, "%s: `--ymax' (`-Y') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->ymax_given && ! override)
            continue;
          local_args_info.ymax_given = 1;
          args_info->ymax_given = 1;
          args_info->ymax_arg = (float)strtod (optarg, NULL);
          break;

        case 'z':	/* Minimum z coordinate.  */
          if (local_args_info.zmin_given)
            {
              fprintf (stderr, "%s: `--zmin' (`-z') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->zmin_given && ! override)
            continue;
          local_args_info.zmin_given = 1;
          args_info->zmin_given = 1;
          args_info->zmin_arg = (float)strtod (optarg, NULL);
          break;

        case 'Z':	/* Maximum Z coordinate.  */
          if (local_args_info.zmax_given)
            {
              fprintf (stderr, "%s: `--zmax' (`-Z') option given more than once%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->zmax_given && ! override)
            continue;
          local_args_info.zmax_given = 1;
          args_info->zmax_given = 1;
          args_info->zmax_arg = (float)strtod (optarg, NULL);
          break;


        case 0:	/* Long option with no short option */

        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */



  if (check_required)
    {
      if (! args_info->density_given)
        {
          fprintf (stderr, "%s: '--density' ('-d') option required%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
          error = 1;
        }
      if (! args_info->inxyz_given)
        {
          fprintf (stderr, "%s: '--inxyz' ('-i') option required%s\n", CMDLINE_PARSER_PACKAGE, (additional_error ? additional_error : ""));
          error = 1;
        }
    }

  if ( error )
    return (EXIT_FAILURE);

  return 0;

failure:
  cmdline_parser_free (&local_args_info);
  return (EXIT_FAILURE);
}
